#ifndef _ATRIBUT_REGLA_ADAPTATIU_
#define _ATRIBUT_REGLA_ADAPTATIU_

#include "attributesInfo.h"
#include "discretizationManager.h"
#include "instance.h"
#include "instanceSet.h"
#include "timerADI.h"
#include "attributesInfo.h"
#include "random.h"

extern discretizationManager disc;
extern timerADI *tADI;
extern instanceSet *is;
extern attributesInfo ai;
extern Random rnd;

void adaptiveAttributeConstructor(int *attribute,int whichAttribute);

inline int adaptiveAttributeRealIntervalValue(int *attribute, int whichInterval)
{
        int i,index;

        for (i = 0,index=2; i < attribute[0]; i++,index+=2) {
                if (whichInterval < attribute[index]) {
                        return (int)attribute[index+1];
		}
        }

        fprintf(stderr,"Error\n");
        exit(1);
}

inline int adaptiveAttributeRealIntervalValue2(int *attribute, int whichMicroInt, int &whichInt)
{
        int i,index;

        for (i = 0,index=2; i < attribute[0]; i++,index+=2) {
                if (whichMicroInt < attribute[index]) {
			whichInt=i;
                        return (int)attribute[index+1];
		}
        }

        fprintf(stderr,"Error\n");
        exit(1);
}


inline int adaptiveAttributeNominalIntervalValue(int *attribute, 
	int whichInterval)
{
        return attribute[whichInterval + 2];
}

void adaptiveAttributeInitializeIntervalValues(int *attribute,int whichAttribute,instance *ins);
void adaptiveAttributeMutation(int *attribute,int whichAttribute);
void adaptiveAttributeDumpPhenotype(int *attribute,int whichAttribute,char *string);
void adaptiveAttributeDoMerge(int *attribute,int whichAttribute,int interval);
void adaptiveAttributeDoSplit(int *attribute,int whichAttribute,int interval);
void adaptiveAttributeDoReinitialize(int *attribute,int whichAttribute);
void adaptiveAttributeDisable(int *attribute,int whichAttribute);
void adaptiveAttributeSetValue(int *attribute,int whichAttribute,int value);
#endif
