#ifndef _ADAPTIVE_RULE_H_
#define _ADAPTIVE_RULE_H_

#include "adaptiveAttribute.h"
#include "instance.h"
#include "attributesInfo.h"
#include "timerADI.h"
#include "timerGlobals.h"
#include "matchProfileAgent.h"

extern attributesInfo ai;
extern timerADI *tADI;
extern timerGlobals *tGlobals;

void adaptiveRuleConstructor(int *rule);

inline int adaptiveRuleMatches(int *rule,instance *ins)
{
	int i;
	int intervalOfSample;

	int *ptr=&rule[2];
	for(i=0;i<tGlobals->numAttributesMC;i++) {
		if (tADI->typeOfAttribute[i] == REAL) {
			intervalOfSample = ins->nominalValuesFromDiscretizers[ptr[1]*tGlobals->numAttributesMC+i];
			if(!adaptiveAttributeRealIntervalValue(ptr
				,intervalOfSample)) return 0;
		} else {
			intervalOfSample = ins->nominalValues[i];
			if(!ptr[2+intervalOfSample]) return 0;
		}
		ptr+=tADI->sizeAdaptiveAttribute[i];
	}
	
	return 1;
}

void adaptiveRuleMutation(int *rule,int defaultClass);
void adaptiveRuleCrossover(int *in1,int *in2,int *out1,int *out2,int cutPoint);
void adaptiveRuleInitialize(int *rule,int defaultClass);
void adaptiveRuleDumpPhenotype(int *rule,char *string,int defaultClass);
int adaptiveRuleDoMerge(int *rule);
int adaptiveRuleDoSplit(int *rule);
int adaptiveRuleDoReinitialize(int *rule);
double adaptiveRuleTheoryLength(int *rule);
int adaptiveRuleCountDiscretizers(int *rule,int attribute,int *counters);
void adaptiveRuleCover(int *rule,instance *ins);
matchProfileAgent *evaluateRuleCX(int *rule);
void adaptiveRuleDisable(int *rule);


#endif
