#include "agentPerformanceTraining.h"
#include "timerGlobals.h"
#include "timerHierar.h"
#include "timerMDL.h"
#include "classifier.h"
#include "messageBuffer.h"

extern timerGlobals *tGlobals;
extern timerMDL *tMDL;
extern timerHierar *tHierar;
extern messageBuffer mb;

agentPerformanceTraining::agentPerformanceTraining(int pNumClassifiers,int pNumClasses)
{
	int i;

	numClasses=pNumClasses;
	numClassifiers=pNumClassifiers;

	numInstancesOK = 0;
	numInstancesNC = 0;
	numInstancesTotal = 0;
	aliveClassifiers=0;

	classifierActivated = new int[numClassifiers];
	for (i = 0; i < numClassifiers; i++) {
		classifierActivated[i] = 0;
	}
}

agentPerformanceTraining::~agentPerformanceTraining()
{
	delete classifierActivated;
}

double agentPerformanceTraining::getFitness(classifier &ind)
{
	double fitness;
	double penalty=1;

	if(aliveClassifiers<tGlobals->penalizeMin) {
		penalty=(1-0.025*(tGlobals->penalizeMin-aliveClassifiers));
		if(penalty<=0) penalty=0.01;
		penalty*=penalty;
	}

	if(tMDL->mdlAccuracy || tHierar->useMDL) {
		ind.computateTheoryLength(this);
	}

	if(tMDL->mdlAccuracy) {
		fitness=tMDL->mdlFitness(ind,this)/penalty;
	} else {
		fitness=getAccuracy();
		fitness*=fitness;
		fitness*=penalty;
	}

	return fitness;
}
