#ifndef _AGENT_PERFORMANCE_TRAINING_H_
#define _AGENT_PERFORMANCE_TRAINING_H_

class classifier;

class agentPerformanceTraining {
	int numClassifiers;
	int numClasses;

	int numInstancesOK;
	int numInstancesNC;
	int numInstancesTotal;
	int *classifierActivated;
	int aliveClassifiers;

public:	
	agentPerformanceTraining(int pNumClassifiers,int pNumClasses);
	~agentPerformanceTraining();

	inline void addPrediction(int realClass,int predictedClass,int usedClassifier) {
		numInstancesTotal++;
		if(usedClassifier!=-1) {
			if(!classifierActivated[usedClassifier]) {
				aliveClassifiers++;
			}
			classifierActivated[usedClassifier]++;
			if (predictedClass == realClass) {
				numInstancesOK++;
			}
		} else {
			numInstancesNC++;
		}
	}
	inline int getActivationsOfClassifier(int classifier) {
		return classifierActivated[classifier];
	}


	inline double getAccuracy() { return (double)numInstancesOK/(double)numInstancesTotal; }
	inline double getNC(){return (double)numInstancesNC/(double)numInstancesTotal;}
	double getFitness(classifier &ind);
	int getAliveClassifiers(){return aliveClassifiers;}

};

#endif
