#ifndef _CLASSIFICADOR_INSTANCIES_
#define _CLASSIFICADOR_INSTANCIES_

#include "classifier.h"
#include "agentPerformanceTraining.h"

class classifier_instances: public classifier   {
	double *chromosome;
	int numInstances;

	void crossover_1px(classifier_instances *in1,classifier_instances *in2
		,classifier_instances *out1,classifier_instances *out2);
	void crossover_2px(classifier_instances *in1,classifier_instances *in2, classifier_instances *out1,classifier_instances *out2);
	double getGene(short int rule,short int attr); 
	void setGene(short int rule,short int attr,double nfo);
	void specialCrossover(double *parent1,double *parent2,double *son1,double *son2);
	void initializeChromosome(void);

public:
	classifier_instances();
	classifier_instances(const classifier_instances &orig,int son=0);
	~classifier_instances();

	inline double getHierarchicalSelectionLength()
	{
		if(tHierar->useMDL) return getTheoryLength();
		return aliveClassifiers;
	}


	int getClass(int rule);
	int getNumClassifiers(){return numInstances;}
	void pruneClassifiers(int *classifiersToPrune,int numPruned);
	int classify(instance *i);
	double computateTheoryLength(agentPerformanceTraining *ap);
	void crossover(classifier *,classifier *,classifier *);
	void mutation();
	void dumpPhenotype(char *string);
	inline int numSpecialStages(){return 0;}
	void doSpecialStage(int stage){}
};

#endif

