#ifndef _CLASSIFIER_LCS_
#define _CLASSIFIER_LCS_

#include "classifier.h"
#include "agentPerformanceTraining.h"
#include "timerGlobals.h"

extern timerGlobals *tGlobals;

class classifier_lcs: public classifier   {
	unsigned char *chromosome;
	int numRules;

	void crossover_1px(classifier_lcs *in1
		,classifier_lcs *in2
		,classifier_lcs *out1
		,classifier_lcs *out2);
	void crossover_2px(classifier_lcs *in1
		,classifier_lcs *in2
		,classifier_lcs *out1
		,classifier_lcs *out2);
	unsigned char getGene(short int rule,short int gene); 
	void setGene(short int rule,short int gene ,unsigned char nfo);
	void initializeChromosome(void);

public:
	classifier_lcs();
	classifier_lcs(const classifier_lcs &orig,int son=0);
	~classifier_lcs();
	int getClass(int rule);
	int getNumClassifiers() {
                int nC=numRules;
                if(tGlobals->defaultClassPolicy!=DISABLED) nC++;
                return nC;
        }


	void pruneClassifiers(int *classifiersToPrune,int numPruned);
	int classify(instance *i);
	double computateTheoryLength(agentPerformanceTraining *ap);

	inline double getHierarchicalSelectionLength()
	{
		if(tHierar->useMDL) return getTheoryLength();
		return numRules;
	}

	void crossover(classifier *,classifier *,classifier *);
	void mutation();
	void dumpPhenotype(char *string);
	inline int numSpecialStages(){return 0;}
	void doSpecialStage(int stage){}

        inline int getNiche() {
                if(tGlobals->defaultClassPolicy!=AUTO) return 0;
                return getClass(getNumClassifiers()-1);
        }
        inline int getNumNiches() {
                if(tGlobals->defaultClassPolicy!=AUTO) return 1;
                return ai.getNumClasses();
        }

};

#endif

