#ifndef _CLASSIFICADOR_OBLIQUE_TREE_
#define _CLASSIFICADOR_OBLIQUE_TREE_

#include "classifier.h"
#include "agentPerformanceTraining.h"

typedef struct NODE{
	int type;
	int leafClass;
	double *hp;
	NODE *left;
	NODE *right;
} node;

class classifier_obliqueTree: public classifier   {
	node *chromosome;
	int numNodes;


	void initializeChromosome(void);

public:
	classifier_obliqueTree();
	classifier_obliqueTree(const classifier_obliqueTree &orig,int son=0);
	~classifier_obliqueTree();

	inline double getHierarchicalSelectionLength()
	{
		return numNodes;
	}


	int getClass(int rule);
	int getNumClassifiers(){return numInstances;}
	void pruneClassifiers(int *classifiersToPrune,int numPruned);
	int classify(instance *i);
	double computateTheoryLength(agentPerformanceTraining *ap);
	void crossover(classifier *,classifier *,classifier *);
	void mutation();
	void dumpPhenotype(char *string);
	inline int numSpecialStages(){return 0;}
	void doSpecialStage(int stage){}
};

#endif

