#ifndef _DISCRETIZATION_MANAGER_H_
#define _DISCRETIZATION_MANAGER_H_

#include "uniformDiscretizer.h"
#include "equalfreqDiscretizer.h"
#include "randDiscretizer.h"
#include "chimergeDiscretizer.h"
#include "mdlpDiscretizer.h"
#include "mantarasDiscretizer.h"
#include "fayyadDiscretizer.h"
#include "id3Discretizer.h"
#include "usdDiscretizer.h"
#include "JVector.h"

class discretizationManager {
	discretizer **discretizers;
	int numD;
	JVector<char *>discNames;
	int numAttributes;
	int ready;

public:
	discretizationManager();
	void setNumAttributes(int num);
	void insertDiscretizer(char *name);
	void createDiscretizer(int num,char *name);
	void setBounds(double *minDomains,double *maxDomains);
	void updateDiscretizers(char *dataFile);
	int getNumDiscretizers(){return numD;}
	inline discretizer *getDiscretizer(int num) {return discretizers[num];}
	int isReady(){return ready;}
};

#endif
