/************************************************************************
 * Discretizer								*
 *                                               Pere Miralles Ribas    *
 ************************************************************************/

#include "discretizer.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int discretizer::contavalors(int i)
{// Conta el numero de valors diferents per l'atribut i
	/*
	int valreals=1;
	for(int k=1;k<numdades;k++)
	{
		if(dades[i][k]!=dades[i][k-1])
			valreals++;
	}
	return valreals;
	*/
	return valorsatribut[i];
}

void discretizer::ordenaVectorQuick(double *vector_num,char ** vector_string,int maxim)
{ // Ordenació per QuickSort
	QuickSort(vector_num,vector_string,0,maxim-1);
}

void discretizer::QuickSort(double *vector_num,char ** vector_string,int i,int j)
{
	int s,t;

	if(i>=j)
	{
		//Cas Trivial	
	}
	if(i<j)
	{
		Particio(vector_num,vector_string,i,j,s,t); // s i t per referencia;
		QuickSort(vector_num,vector_string,i,t);
		QuickSort(vector_num,vector_string,s,j);
	}
}

void discretizer::Particio(double *vector_num,char ** vector_string,int i,int j,int &s, int &t)
{
	double pivot, tmp_num;
	char tmp_char[20];
	div_t mig; 

	s=i;
	t=j;
	
	mig=div((i+j),2);
	pivot=vector_num[mig.quot];
	
	while(s<=t)
	{
		while(vector_num[s]<pivot)
			s=s+1;
		while(vector_num[t]>pivot)
			t=t-1;
		if(s<t)
		{
			tmp_num=vector_num[s];
			if(vector_string!=NULL) strcpy(tmp_char,vector_string[s]);
			
			vector_num[s]=vector_num[t];
			if(vector_string!=NULL) strcpy(vector_string[s],vector_string[t]);
			
			vector_num[t]=tmp_num;
			if(vector_string!=NULL) strcpy(vector_string[t],tmp_char);
			
			s=s+1;
			t=t-1;
		}
		else if( s==t)
		{
			s=s+1;
			t=t-1;
		}
	}
	
}
                                                                        
void discretizer::ordenaVectorBubble(double *vector_num,char ** vector_string,int maxim)
{ // Ordenació per BubbleSort
	int menor;
	double aux_num;
	char aux_char[20];

	for(int i=0;i<maxim-1;i++)
	{
		menor=i;
		for(int j=i+1;j<maxim;j++)
		{
			if(vector_num[menor]>vector_num[j])
				menor=j;
		}
		aux_num=vector_num[i];
		strcpy(aux_char,vector_string[i]);
		
		vector_num[i]=vector_num[menor];
		strcpy(vector_string[i],vector_string[menor]);
		
		vector_num[menor]=aux_num;
		strcpy(vector_string[menor],aux_char);
	}
}
void discretizer::demanaMatriuDouble(double ** &matriu,int x,int y)
{ // Demana memoria per a una matriu de dades de doble

	matriu = new double *[x];
	if(matriu==NULL)
	{
		fprintf(stderr,"Error memoria insuficent a discretizer");
		exit(1);
	}
	for(int i=0;i<x;i++)
	{
		matriu[i]=new double[y];
		if(matriu[i]==NULL)
		{
			fprintf(stderr,"Error memoria insuficient a discretizer");
			exit(1);
		}
	}
}

void discretizer::demanaMatriuInt(int ** &matriu,int x,int y)
{ // Demana memoria per a una matriu de dades integer

	matriu = new int *[x];
	if(matriu==NULL)
	{
		fprintf(stderr,"Error memoria insuficent a discretizer");
		exit(1);
	}
	for(int i=0;i<x;i++)
	{
		matriu[i]=new int[y];
		if(matriu[i]==NULL)
		{
			fprintf(stderr,"Error memoria insuficient a discretizer");
			exit(1);
		}
	}
}




void discretizer::demanaMatriuString(char *** &matriu,int x,int y,int longitud)
{ // Demana memoria per a una matriu de strings
	
	matriu= new char **[x];
	if(matriu==NULL)
	{
		fprintf(stderr,"Error memoria insuficent a discretizer");
		exit(1);				
	}
	for(int i=0;i<x;i++)
	{
		matriu[i]=new char *[y];
		if(matriu[i]==NULL)
		{
			fprintf(stderr,"Error memoria insuficent a discretizer");
			exit(1);
		}
		else
		{
			for(int j=0;j<y;j++)
			{
				matriu[i][j]=new char[longitud];
				if(matriu[i]==NULL)
				{
					fprintf(stderr,"Error memoria insuficent a discretizer");
					exit(1);						
				}				
			}
		}
	}
}

void discretizer::demanaVectorString(char ** &vector,int num,int longitud)
{
	vector=new char *[num];
	if(vector==NULL)
	{
		fprintf(stderr,"Error memoria insuficient a discretizer");
		exit(1);
	}
	for(int i=0;i<num;i++)
	{
		vector[i]=new char[longitud];
		if(vector[i]==NULL)
		{
			fprintf(stderr,"Error memoria insuficient a discretizer");
			exit(1);
		}
	}
}

void discretizer::demanaVectorInt(int *&vector,int longitud)
{
	vector=new int [longitud];

	if(vector==NULL)
	{
		fprintf(stderr,"Error memoria insuficient a discretizer");
		exit(1);
	}
	for(int i=0;i<longitud;i++)
		vector[i]=0;

}

void discretizer::demanaVectorDouble(double *&vector,int longitud)
{

	vector=new double [longitud];
	if(vector==NULL)
	{
		fprintf(stderr,"Error memoria insuficient a discretizer");
		exit(1);
	}
	for(int i=0;i<longitud;i++)
		vector[i]=0;
}

void discretizer::parserFitxer(char* dataFile)
{ // Fa un primer "parsejat" del fitxer per saber el numero d'atributs i de dades del fitxer

	FILE *fp = fopen(dataFile, "r");
        char buffer[10000];
	
	numatributs=0;
	numdades=0;
	
	if (!fp) 
	{
    		fprintf(stderr, "Can't open %s\n", dataFile);
		exit(1);
	}
	
	fgets(buffer,9999,fp);
	while(!feof(fp))
	{
		buffer[strlen(buffer)-1]=0;
		if(!strncasecmp(buffer,"%",1)) { // La linea es un comentari
		} else if(!strncasecmp(buffer,"@relation",9) || !strncasecmp(buffer,"@RELATION",9)) { // Indica una relació
		} else if(!strncasecmp(buffer,"@attribute",10) || !strncasecmp(buffer,"@ATTRIBUTE",10)) { // Indica un atribut
			numatributs++;
		} else if(!strncasecmp(buffer,"@data",5)) {
		} else if(!strcmp(buffer,"")) {
		} else { // Son dades del fitxer
			numdades++;
		}
		fgets(buffer,9999,fp);
	}
	numatributs--;
	fclose(fp);
	
	demanaMatriuDouble(dades,numatributs,numdades);
	demanaMatriuString(classes,numatributs,numdades,20);
	demanaVectorInt(tipusatributs,numatributs); // 3 Real 2 Enter 1 Nominal				
	demanaVectorDouble(mitjaatributs,numatributs);
	
}

void discretizer::carregarDades(char *dataFile)
{ // Omle un seguit d'estructures de dades amb la informacio de fitxer: dades,classes,tipusatributs.
	
	FILE *fp = fopen(dataFile, "r");
	char buffer[10000];
	int numAtribut=0;
	int acabar=0;
	int dada=0;
	float llegit=0;
	int retornllegit=0;
	

	if (!fp)
	{
		fprintf(stderr, "Can't open %s\n", dataFile);
		exit(1);
	}

	fscanf(fp,"%s",buffer);
	while(!feof(fp) && !acabar)
	{
		if(!strncasecmp(buffer,"%",1))
		{ // La linea es un comentari
			fgets(buffer,9999,fp);
		}
		else if(!strncasecmp(buffer,"@relation",9) || !strncasecmp(buffer,"@RELATION",9))
		{ // Indica una relació
			fgets(buffer,9999,fp);
		}
		else if(!strncasecmp(buffer,"@attribute",10))
		{ // Indica un atribut
			fscanf(fp,"%s",buffer); // Identificador de l'atribut
			fscanf(fp,"%s",buffer); // Tipus de l'atribut
			if(!strncasecmp(buffer,"real",4))
			{ // l'atribut es real
				tipusatributs[numAtribut]=3; // Real
				numAtribut++;
				fgets(buffer,9999,fp);
			}
			else if(!strncasecmp(buffer,"integer",7))
			{ // l'atribut es enter
				tipusatributs[numAtribut]=2; // Enter
				numAtribut++;
				fgets(buffer,9999,fp);
			}
			else if(buffer[0]=='{')
			{
				if(numAtribut==numatributs)
				{// Es la classe
					numclasses=0;
					for(int i=0;i<strlen(buffer);i++)
					{
						if(buffer[i]==',' || buffer[i]=='}')
						{
							numclasses++;
						}
					}
					demanaVectorString(nomclasses,numclasses,20);
					int cont=0;
					int j=0;
					for(int i=1;i<strlen(buffer);i++)
					{
						switch (buffer[i])
						{
							case ',':
							case '}':
								nomclasses[cont][j]='\0';
								cont++;
								j=0;
								break;
							default:
								nomclasses[cont][j]=buffer[i];
								j++;
								break;
						}
						

					}
				}
				else
				{
					tipusatributs[numAtribut]=1; // Nominal
					numAtribut++;				
				}
					
				fgets(buffer,9999,fp);
			}
			else
			{
				fprintf(stderr,"Error tipus no definit");
				exit(1);
			}
		
		}
		else if(!strncasecmp(buffer,"@data",5) || !strncasecmp(buffer,"@DATA",5))
		{
			fgets(buffer,9999,fp);
			acabar=1;
		}
		if(!acabar)
		{
			strcpy(buffer,"");
			fscanf(fp,"%s",buffer);
		}
	}

	dada=0;
	while(!feof(fp) && dada<numdades)
	{
	
		for(int i=0;i<numatributs;i++)
		{
			switch (tipusatributs[i])
			{
				case 1: // Nominal
					fscanf(fp,"%c",&(buffer[0]));
					while(buffer[0]!=',')
					{
						fscanf(fp,"%c",&(buffer[0]));
					}
					dades[i][dada]=-1;
					break;
				case 2: // Enter
				case 3: // Real
					retornllegit=fscanf(fp,"%f",&llegit);
					if(retornllegit==0) // Hem trobat un ?
					{
						fscanf(fp,"%c",&(buffer[0])); // llegim el ?
						llegit=mitjaatributs[i]/dada; // Asignem el valor de la mitja
					}
					
					dades[i][dada]=(double)llegit;
					mitjaatributs[i]=mitjaatributs[i]+dades[i][dada];
					fscanf(fp,"%c",&(buffer[0]));
					break;
			}
		}
		fscanf(fp,"%s",buffer);
		for(int j=0;j<numatributs;j++)
		{
			strcpy(classes[j][dada],buffer);
		}
		dada++;
		fgets(buffer,9999,fp);
	}
	fclose(fp);
}


void discretizer::inicontador(int *classemaj)
{
	for(int i=0;i<numclasses;i++)
		classemaj[i]=0;
}

int discretizer::buscanumclasse(int *classemaj,char * nom)
{
	for(int i=0;i<numclasses;i++)
	{
		if(!strcmp(nom,nomclasses[i]))
			return i;
	}
	fprintf(stderr,"nom de l'atribut incorrecte a ORD");
	exit(1);
	return -1; // Error
}

int discretizer::esclassemaj(int *classemaj,char *nom)
{
	int num=-1;
	int esclassemaj=1;
	for(int i=0;i<numclasses;i++)
	{
		if(!strcmp(nom,nomclasses[i]))
			num=classemaj[i];
	}
	for(int i=0;i<numclasses;i++)
	{
		if(classemaj[i]>num)
			esclassemaj=0;
	}
	return esclassemaj;
}

int discretizer::posclassemaj(int *classemaj)
{ // Arreglar en cas de ser iguals!!!

	int max=-MAX_DOUBLE;
	int pos=-1;
	for(int i=0;i<numclasses;i++)
	{
		if(classemaj[i]>max)
		{
			pos=i;
			max=classemaj[i];
		}
	}
	return pos;
}

void discretizer::compactardades()
{
	int dadesacum=0;
	int dadescomp=0;
	int pos;
//	int * classemaj;
	
//	demanaVectorInt(classemaj,numclasses);
	demanaMatriuDouble(dadesc,numatributs,numdades);
	demanaVectorInt(valorsatribut,numatributs);
//	demanaMatriuString(classesc,numatributs,numdades,20);
	
	for(int i=0;i<numatributs;i++)
	{ // Per a tots els atributs
	
		if(tipusatributs[i]==3 || tipusatributs[i]==2)
		{ // Només reals i enters
			ordenaVectorQuick(dades[i],classes[i],numdades);
			dadesacum=0;
			dadescomp=0;
			//inicontador(classemaj);
			while(dadesacum<numdades)
			{
				if(dadesacum<numdades-1 && dades[i][dadesacum]==dades[i][dadesacum+1])
				{
					//pos=buscanumclasse(classemaj,classes[i][dadesacum]);
					//classemaj[pos]=classemaj[pos]+1;
					dadesacum++;
				}
				else
				{
					//pos=buscanumclasse(classemaj,classes[i][dadesacum]);
					//classemaj[pos]=classemaj[pos]+1;
					dadesc[i][dadescomp]=dades[i][dadesacum];
					//strcpy(classesc[i][dadescomp],nomclasses[posclassemaj(classemaj)]);
				        //inicontador(classemaj);
					dadescomp++;
					dadesacum++;
				}
			}
			valorsatribut[i]=dadescomp;
		}
	}
}

double discretizer::getCutPoint(int attribute,int cp)
{
	return cutPoints[attribute][cp];
}
