/************************************************************************
 * Discretizer                                                          *
 *                                               Pere Miralles Ribas    *
 ************************************************************************/

#ifndef _DISCRETIZER_H_
#define _DISCRETIZER_H_

#define MAX_DOUBLE 9999999

#include <math.h>


class discretizer {
protected:
	double *minDomain;	// Minims de cada atribut
	double *maxDomain;	// Maxim de cada atribut
	int numAttributes;	// Numero d'atibuts
	int *numIntervals;	// Numero d'intervals per atribut

	int numatributs;	// Numero d'atributs
	int numdades;		// Numero de dades del fitxer
	double ** dades;	// Dades del fitxer
	char *** classes;	// Classes dels atributs (classe de la mostra replicada per cada atribut)
	double ** dadesc;       // Dades de fitxer COMPACTES
	int *valorsatribut;	// Numero de valors per atribut
	//char *** classesc;      // Classes dels atributs COMPACTES
		
	int * tipusatributs;	// Tipus dels atributs
	int numclasses;		// Numero de classes que te el problema
	char ** nomclasses;	// Nom de les classes del problema
	double *mitjaatributs;	// Valor mig de cada atribut (per si trobem un ?) (Acumulacio per calcular la mitja)

        double **cutPoints;
        int *numCutPoints;
	
	// Ordenacio
	void ordenaVectorBubble(double *vector_num,char ** vector_string,int maxim);
	void ordenaVectorQuick(double *vector_num,char ** vector_string,int maxim);		
	void QuickSort(double *vector_num,char ** vector_string,int i,int j);
	void Particio(double *vector_num,char ** vector_string,int i,int j,int &s, int &t);	
	// Memoria
	void demanaMatriuDouble(double ** &matriu,int x,int y);
	void demanaMatriuString(char *** &matriu,int x,int y,int longitud);
	void demanaMatriuInt(int **&matru,int x, int y);	
	void demanaVectorString(char **&vector,int num,int longitud);
	void demanaVectorInt(int *&vector,int longitud);
	void demanaVectorDouble(double *&vector,int longitud);
	// Discretitzacio
	int contavalors(int i);
	// Dades
	void parserFitxer(char* dataFile);
	void carregarDades(char *dataFile);
	//Compactacio
	void compactardades();
	void inicontador(int * classemaj);
	int buscanumclasse(int *classemaj, char * nom);
	int esclassemaj(int * classemaj,char *nom);
	int posclassemaj(int * classemaj);

public:
	virtual void setBounds(double *min,double *max)=0;
	virtual int discretize(int attribute,double value)=0;
	virtual void updateDiscretizer(char *dataFile)=0;
	virtual int getNumIntervals(int attribute)=0;
	virtual void results()=0;
	double getCutPoint(int attribute,int cp);


};

#endif
