/************************************************************************
 * MDLP Discretizer 					*
 *						 Pere Miralles Ribas    *
 ************************************************************************/

#ifndef _EQUALFREQ_DISCRETIZER_H_
#define _EQUALFREQ_DISCRETIZER_H_

#include "discretizer.h"
#include "JVector.h"

class equalfreqDiscretizer: public discretizer {
	bool **missing;
	char **classes;
	int numClasses;
	double **realValues;
	bool *realAttributes;
	int *classOfInstances;
	int numAttributes;
	int numInstances;
	int numBins;

	void readFile(char *datafile);
	void cleanMemory();
	void doDiscretize();
	void sortValues(int attribute,int *values,int begin,int end);
	void discretizeAttribute(int attribute,int *values,int begin,int end,double *cutPoints,int &numCP);
		
public:
	equalfreqDiscretizer(int bins,int attributes);
	~equalfreqDiscretizer();
	void setBounds(double *min,double *max);
	int discretize(int attribute, double value);
	void updateDiscretizer(char *dataFile);
	int getNumIntervals(int attr);
	void results();
};

#endif
