#include "fayyadDiscretizer.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/types.h>
#include <unistd.h>
#include "messageBuffer.h"

extern messageBuffer mb;

void fayyadDiscretizer::results()
{
        double numTotal=0;
        double numAttr=0;
        for(int i=0;i<numAttributes;i++)
        { // Per a tots els atributs
		if(numCutPoints[i]!=-1) {
			numAttr++;
			numTotal+=numCutPoints[i];
		}
        }
        mb.printf("Numero de punts de tall Discretitzacio : %g\n",numTotal/numAttr);
}



fayyadDiscretizer::fayyadDiscretizer(int attributes)
{
	numAttributes = attributes;
	cutPoints = new double *[numAttributes];
	numCutPoints = new int[numAttributes];

	int i;
	for (i = 0; i < numAttributes; i++)
		numCutPoints[i] = -1;
}

void fayyadDiscretizer::setBounds(double *min, double *max)
{
}

void fayyadDiscretizer::llegeixConfiguracio(char *config)
{
	FILE *fp = fopen(config, "r");
	if (!fp) {
		fprintf(stderr, "Can't open %s\n", config);
		exit(1);
	}

	char buffer[100];

	fgets(buffer, 99, fp);
	while (!feof(fp)) {
		if (strncmp(buffer, "num intervals atribut ", 22)) {
			fprintf(stderr, "Parse error1 a llegeixConf:%s\n",
				buffer);
			exit(1);
		}

		int atribut, numCP;
		if (sscanf(buffer + 22, "%d : %d", &atribut, &numCP) != 2) {
			fprintf(stderr, "Parse error2 a llegeixConf:%s\n",
				buffer);
			exit(1);
		}

		if (atribut < 0 || atribut >= numAttributes) {
			fprintf(stderr,
				"Wrong attribute a llegeixConf:%s\n",
				buffer);
			exit(1);
		}

		if (numCutPoints[atribut] != -1) {
			fprintf(stderr,
				"Attribute cut points already defined:%s\n",
				buffer);
			exit(1);
		}

		//printf("Number of cutpoints for attribute %d:%d\n",
		//       atribut, numCP);

		numCutPoints[atribut] = numCP;
		if (numCP)
			cutPoints[atribut] = new double[numCP];
		int i;
		for (i = 0; i < numCP; i++) {
			fgets(buffer, 99, fp);
			if (feof(fp)) {
				fprintf(stderr,
					"EOF error a llegeixConf\n");
				exit(1);
			}
			int atr, val;
			float punt;

			if (sscanf
			    (buffer, "interval atribut %d i valor %d : %f",
			     &atr, &val, &punt) != 3) {
				fprintf(stderr,
					"Parse error3 a llegeixConf:%s\n",
					buffer);
				exit(1);
			}
			if (atr != atribut || val != i) {
				fprintf(stderr,
					"Cut point def does not match atr %s\n",
					buffer);
				exit(1);
			}

			if (i > 0 && punt < cutPoints[atribut][i - 1]) {
				fprintf(stderr,
					"Cut point must be ordered %s\n",
					buffer);
				exit(1);
			}

			//printf("Cutpoint %d of attribute %d:%f\n", i,
			//       atribut, punt);
			cutPoints[atribut][i] = punt;
		}

		fgets(buffer, 99, fp);
	}

	fclose(fp);
}

void fayyadDiscretizer::updateDiscretizer(char *dataFile)
{
	char comanda[1000];
	sprintf(comanda, "java DiscretizeFilterFayyad %s > tempConf%d",
		dataFile, getpid());
	system(comanda);
	sprintf(comanda, "tempConf%d", getpid());
	llegeixConfiguracio(comanda);
	unlink(comanda);
	results();
}

int fayyadDiscretizer::discretize(int attribute, double value)
{
	int i;

	if (numCutPoints[attribute] == 0)
		return 0;

	for (i=0; i < numCutPoints[attribute] && value>=cutPoints[attribute][i]; i++);

	return i;
}
