#ifndef _INSTANCE_H_
#define _INSTANCE_H_

#define ATT_PER_BLOCK ((8*sizeof(unsigned int))/2)
#define ATT_MASK 0x3U
#define ALL_MASK ((unsigned int)-1)
#define GET_ATT(INS,IDX) ((INS&(ATT_MASK<<(2*IDX)))>>(2*IDX))
#define SET_ATT(INS,IDX,VAL) (INS=(((ALL_MASK^(ATT_MASK<<(2*IDX)))&INS)|(VAL<<(2*IDX))))


#define TRAIN 1
#define TEST 2

typedef unsigned int __attribute__ ((aligned (4))) aligned_uint;

class instance {
	int numAttributes;
	int traintest;
	char *missing;
	int missingValues;

	int noRealAtt;

	void parseInstance(char *string);
	int extractNominalValue(char *instance,int attribute);
	int extractRealValue(double instance,int attribute);

public:
	unsigned char *nominalValues;
	aligned_uint *packedRepresentation;
	double *realValues;
	int instanceClass;
	unsigned char *nominalValuesFromDiscretizers;
	instance(char *string,int traintest);
	instance();
	~instance();
	inline int valueOfAttribute(int attribute){return nominalValues[attribute];}
	inline int valueOfAttributeFromDiscretizer(int attribute,int discretizer)
		{return nominalValuesFromDiscretizers[discretizer*numAttributes+attribute];}
	inline int getClass(){return instanceClass;}
	inline int hasMissingValues(){return missingValues;}
	void updateRealValuedAttributes();
	void updateMissing();
	inline int isMissing(int atr){return missing[atr];}
	inline double realValueOfAttribute(int attribute){return realValues[attribute];}
	double distance(instance *ins);
	void dumpInstance();
	void generatePackedRepresentation();
};

#endif
