#ifndef _INSTANCE_SET_VIRTUAL_
#define _INSTANCE_SET_VIRTUAL_

#include <stdio.h>
#include "JVector.h"
#include "windowingVirtual.h"
#include "sampling.h"
#include "instanceSet.h"
#include "datasetGenerator.h"
#include "attributesInfo.h"

#define TRAIN 1
#define TEST 2

class instance;

extern attributesInfo ai;

class instanceSetVirtual : public instanceSet {
private:
	Sampling **initSamplings;
	int *countsByClass;
	int **instByClass;
	void initInstanceLists();
	int numClasses;
	int classWiseInit;

	unsigned long long numInstances;

	int windowingEnabled;
	instance **window;
	int windowSize;
	windowingVirtual *win;

	datasetGenerator *gen;

	instance *temp;

	void generateDataset(int traintest);
	void initializeWindowing(int traintest);

public:
	instanceSetVirtual(int traintest);
	~instanceSetVirtual();

	inline instance *getInstance(unsigned long long index) {
		if(windowingEnabled) return window[index];
	
		gen->generateInstance(temp,index);
                if(ai.allAttributesBinary())
                        temp->generatePackedRepresentation();
		return temp;
	}

	inline instance *getInstanceTest(unsigned long long index) {
		gen->generateInstance(temp,index);
                if(ai.allAttributesBinary())
                        temp->generatePackedRepresentation();
		return temp;
	}


	inline instance **getInstancesOfIteration() {
		if(windowingEnabled) return window;
		fprintf(stderr,"Cannot return whole instance set for virtual dataset\n");
		exit(1);
	}

	instance *getInstanceInit(int forbiddenCL);

	inline instance **getAllInstances(){}

	inline int isWindowingEnabled() {return windowingEnabled;}
	unsigned long long getNumInstancesOfIteration();
	int newIteration(int isLast);
	inline unsigned long long getNumInstances(){return numInstances;}
	int numVersions();
	int getCurrentVersion();
};



#endif
