/************************************************************************
 * Mantaras Distance Discretizer 					*
 ************************************************************************/

#ifndef _MANTARAS_DISCRETIZER_H_
#define _MANTARAS_DISCRETIZER_H_

#include "discretizer.h"
#include "JVector.h"

class mantarasDiscretizer: public discretizer {
	bool **missing;
	char **classes;
	int numClasses;
	double **realValues;
	bool *realAttributes;
	int *classOfInstances;
	int numAttributes;
	int numInstances;
	int *candidateCutPoints;
	int *cutPointsMask;
	int numCandidates;
	int *cd,*classCount;
	int numC;
	int numV;

	void readFile(char *datafile);
	void cleanMemory();
	void doDiscretize();
	void sortValues(int attribute,int *values,int begin,int end);
	void discretizeAttribute(int attribute,int *values,int begin,int end,double *cutPoints,int &numCP);
	int getBestCandidate(int attribute,int *values, int begin,int end,double entClass);
	double computePartitionDistance(int attribute,int *values, int begin,int end,int newCP,double entClass);
	double computeClassEntropy(int attribute,int *values,int begin,int end);
	void classDistribution(int attribute,int *values,int begin,int end,int *cd,int &numC,int &numV);
	void getCandidateCutPoints(int attribute,int *values,int begin,int end);
	double computeEntropy(int *cd,int numC,int numV);
	int doCutPoint(int attribute,int *values,int begin,int end,int cutP);
	double doCutPoint2(int attribute,int *values,int begin,int end);
	double log2(double val);
		
public:
	mantarasDiscretizer(int attributes);
	~mantarasDiscretizer();
	void setBounds(double *min,double *max);
	int discretize(int attribute, double value);
	void updateDiscretizer(char *dataFile);
	int getNumIntervals(int attr);
	void results();
};

#endif
