/************************************************************************
 * MDLP Discretizer 					*
 *						 Pere Miralles Ribas    *
 ************************************************************************/

#ifndef _MDLP_DISCRETIZER_H_
#define _MDLP_DISCRETIZER_H_

#include "discretizer.h"
#include "JVector.h"

class mdlpDiscretizer: public discretizer {
	bool **missing;
	char **classes;
	int numClasses;
	double **realValues;
	bool *realAttributes;
	int *classOfInstances;
	int numAttributes;
	int numInstances;
	int *candidateCutPoints;
	int numCandidates;
	int *cd1,*cd2,*cd,*classCount;
	int numC1,numC2,numC;
	int numV1,numV2,numV;

	void readFile(char *datafile);
	void cleanMemory();
	void doDiscretize();
	void sortValues(int attribute,int *values,int begin,int end);
	void discretizeAttribute(int attribute,int *values,int begin,int end,double *cutPoints,int &numCP);
	double computePartitionEntropy(int attribute,int *values,int begin,int midPoint,int end);
	bool partitionPure(int attribute,int *values,int begin,int end);
	void classDistribution(int attribute,int *values,int begin,int end,int *cd,int &numC,int &numV);
	void getCandidateCutPoints(int attribute,int *values,int begin,int end);
	double computeEntropy(int *cd,int numC,int numV);
	int doCutPoint(int attribute,int *values,int begin,int midPoint,int end);
	double log2(double val);
		
public:
	mdlpDiscretizer(int attributes);
	~mdlpDiscretizer();
	void setBounds(double *min,double *max);
	int discretize(int attribute, double value);
	void updateDiscretizer(char *dataFile);
	int getNumIntervals(int attr);
	void results();
};

#endif
