#ifndef _MX_GENERATOR_
#define _MX_GENERATOR_

#include "datasetGenerator.h"
#include "math.h"
#include "random.h"

extern Random rnd;

class mxGenerator : public datasetGenerator {
	int size;
	int numAddr;
	int *tmpInst;
public:
	mxGenerator(int pNumAddr);

	void initialize();

	inline double getNumInstances() { return pow(2,size); }

	
	inline int classOfInstance(unsigned long long instanceID) {
		int i,index;
		for(i=0,index=size-1;i<size;i++,index--) {
			tmpInst[index]=instanceID%2;
			instanceID>>=1;
		}

		int base=0;
		for(i=0;i<numAddr;i++) {
			base<<=1;
			base+=tmpInst[i];
		}
		return tmpInst[numAddr+base];
	}

	inline instance *generateInstance(unsigned long long instanceID) {
		instance *ins = new instance();
		
		int i,index;
		for(i=0,index=size-1;i<size;i++,index--) {
			ins->nominalValues[index]=instanceID%2;
			instanceID>>=1;
		}

		int base=0;
		for(i=0;i<numAddr;i++) {
			base<<=1;
			base+=ins->nominalValues[i];
		}
		ins->instanceClass=ins->nominalValues[numAddr+base];

		return ins;
	}

	inline instance *generateRandomInstance() {
		instance *ins = new instance();
		
		int i;
		for(i=0;i<size;i++) {
			ins->nominalValues[i]=rnd(0,1);
		}

		int base=0;
		for(i=0;i<numAddr;i++) {
			base<<=1;
			base+=ins->nominalValues[i];
		}
		ins->instanceClass=ins->nominalValues[numAddr+base];

		return ins;
	}


	inline void generateInstance(instance *ins,unsigned long long instanceID) {
		
		int i,index;
		for(i=0,index=size-1;i<size;i++,index--) {
			ins->nominalValues[index]=instanceID%2;
			instanceID>>=1;
		}

		int base=0;
		for(i=0;i<numAddr;i++) {
			base<<=1;
			base+=ins->nominalValues[i];
		}
		ins->instanceClass=ins->nominalValues[numAddr+base];
	}
};

#endif
