/************************************************************************
 * Random Discretizer                                                   *
 *                                               Pere Miralles Ribas    *
 ************************************************************************/

#include "randDiscretizer.h"
#include "random.h"
#include <stdio.h>
#include <stdlib.h>
#include "messageBuffer.h"

extern messageBuffer mb;
extern Random rnd;

void randDiscretizer::results()
{
        double numpttotals=0;
        double numAttr=0;
        for(int i=0;i<numatributs;i++)
        { // Per a tots els atributs
                if(tipusatributs[i]==3 || tipusatributs[i]==2)
                {
                        numAttr++;
                        numpttotals=numpttotals+numCutPoints[i];
                }
        }
        mb.printf("Numero de punts de tall Discretitzacio : %g\n",numpttotals/numAttr);

}

void randDiscretizer::updateDiscretizer(char *dataFile)
{
	parserFitxer(dataFile);
	carregarDades(dataFile);
	compactardades();
	discretitzador();
	results();

}

int randDiscretizer::acabar(int *espt,int limit,int maxpt)
{
	int numpt;
	numpt=0;
	for(int i=0;i<limit;i++)
	{
		if(espt[i]==1)
			numpt++;		
	}
	return numpt>=maxpt;
}


void randDiscretizer::discretitzador()
{
	double *ptpos;
	int *espt;
	int limit,numpt;
		
	for(int i=0;i<numatributs;i++)
	{ // Per a tots els atributs
		if(tipusatributs[i]==3 || tipusatributs[i]==2)
		{ // Nomes per als atributs numerics
			limit=contavalors(i);
			numpt=rnd(0,limit-2);
			numCutPoints[i]=numpt;
			demanaVectorDouble(cutPoints[i],numpt);
			//numero de talls aleatori
			demanaVectorDouble(ptpos,limit-1);
			demanaVectorInt(espt,limit-1);
			inicialitzapt(ptpos,espt,i,limit-1);
			while(!acabar(espt,limit-1,numpt))
			{ // pt aleatori entre tots els possibles pt
				espt[rnd(0,limit-2)]=1;
			}
			numpt=0;
			for(int j=0;j<limit-1;j++)
			{
				if(espt[j]==1)
				{
					cutPoints[i][numpt]=ptpos[j];	
					numpt++;
				}
					
			}			
		}
	}

}

void randDiscretizer::inicialitzapt(double *ptpos,int *espt,int atribut,int limit)
{
	for(int i=0;i<limit;i++)
	{
		ptpos[i]=(dadesc[atribut][i]+dadesc[atribut][i+1])/2;
		espt[i]=0;
	}
}


randDiscretizer::randDiscretizer(int attributes)
{
	numAttributes = attributes;
	demanaVectorInt(numCutPoints,attributes);               // Numero de punts de tall per atribut
	cutPoints = new double *[numAttributes];                // Punts de tall per atribut
	demanaVectorDouble(minDomain,numAttributes);
	demanaVectorDouble(maxDomain,numAttributes);
}


void randDiscretizer::setBounds(double *min, double *max)
{
	int i;
	for (i = 0; i < numAttributes; i++)
	{
		minDomain[i] = min[i];
		maxDomain[i] = max[i];
	}
}

int randDiscretizer::getNumIntervals(int attr)
{
	        return numCutPoints[attr]+1;
}

int randDiscretizer::discretize(int attribute, double value)
{
	if (numCutPoints[attribute] == 0)
		return 0;
	for(int i=0;i<numCutPoints[attribute];i++)
	{
		if(value<cutPoints[attribute][i])
			return i;
		}
	return numCutPoints[attribute];
}
