#ifndef _RULE_ORDER_AGENT_H_
#define _RULE_ORDER_AGENT_H_

#include "JVector.h"
#include "matchProfileAgent.h"

class ruleOrderAgent {
	int defaultClass;
	unsigned long long numInstances;
	char *isMatchedOK;
	int *ruleMatching;
	double *ratioOfClass;
	int numClasses;
	unsigned long long numOK;
	int numRules;
	double accuracy; 
	JVector<int> rules;
	JVector<matchProfileAgent *>profiles;
	matchProfileAgent *mpaDR;

	void addRule(int whichRule,matchProfileAgent *mpa,int whichPos);
	double accuracyOfPosition(int pos,matchProfileAgent *mpa);

	inline double min(double a,double b) {
	        if(a<b) return a;
	        return b;
	}

public:

	ruleOrderAgent(int pDefaultClass,unsigned long long pNumInstances,int capacity);
	~ruleOrderAgent();
	int insertRule(int whichRule,matchProfileAgent *mpa);
	matchProfileAgent *generateActualMPA(int rule);
	void removeMatchesOfRule(int rule,matchProfileAgent *mpa);
	inline int getRule(int rule) { return rules[rule];}
	void refineRuleSet();
	void copyOrder(JVector<int> &finalRules);
	inline double getAccuracy() {return accuracy;}
	inline int getNumRules() {return numRules;}
	void removeRule(int whichPos);
	void getPossibleInstancesOfRule(int rule,unsigned long long *instances,unsigned long long &numInst);
	void getNegativeExamples(int rule,unsigned long long *instances,unsigned long long &numInst);
	void addPositiveExamples(int rule,unsigned long long *instances,unsigned long long numInst
		,matchProfileAgent *mpa);
	void updateMPA(int rule,matchProfileAgent *mpa);
	unsigned long long ruleNeedsInstances(int rule);
};

#endif
