#ifndef _TIMER_ADI_H_
#define _TIMER_ADI_H_

#include "timingProcess.h"
#include "probabilityManagement.h"

#define SPLIT 0
#define MERGE 1
#define REINITIALIZE 2

class timerADI : public timingProcess {
	int enabled;
	void dumpDiscretizersInPopulation(int iteration);
	int popSize;
	int dumpDiscretizersEnabled;
	int reinitializeEnabled;
	int totalIterations;
	int numAttributes;
	int numDiscretizers;
	char lastOrder[4];
	int numRepeatedOrder;

public:
	int *stageOrder;
	int *sizeAdaptiveAttribute;
	int *offsetAdaptiveAttribute;
	int *typeOfAttribute;
	int numMaxIntervals;
	double probMergeInterval;
	double probSplitInterval;
	double probReinitializeAttribute;
	int ruleSize;
	double defaultRuleTheoryLength;
	probabilityManagement *probReinitManager;

	int numSplit, numMerge, numReinitialize, numMergeFailed, 
		numMergeAttempts;
	int *bestDiscretizers;
	int *worstDiscretizers;


	timerADI();
	void initialize(populationWrapper *pPW) {pw=pPW;}
	void newIteration(int iteration,int finalIteration);
	void dumpStats(int iteration);
};

#endif
