#include "timerGlobals.h"
#include "timerEvolutionStats.h"
#include "attributesInfo.h"
#include "instanceSet.h"
#include "messageBuffer.h"

extern messageBuffer mb;

extern attributesInfo ai;

timerGlobals::timerGlobals()
{
	minClassifiersInit = 
		(int) cm.getParameter(INITIALIZATION_MIN_CLASSIFIERS);
	maxClassifiersInit = 
		(int) cm.getParameter(INITIALIZATION_MAX_CLASSIFIERS);
	cxOperator = (int) cm.getParameter(CROSSOVER_OPERATOR);
	
	if (cm.thereIsParameter(IGNORE_MISSING_VALUES)) {
		ignoreMissingValues = 1;
	} else {
		ignoreMissingValues = 0;
	}

	if (cm.thereIsParameter(PENALIZE_MIN_SIZE)) {
		penalizeMin=(int)cm.getParameter(PENALIZE_MIN_SIZE);
	} else {
		penalizeMin=0;
	}

	defaultClassPolicy=(int)cm.getParameter(DEFAULT_CLASS);
	defaultClass=-1;
	switch(defaultClassPolicy) {
		case MAJOR:
			numClasses=ai.getNumClasses()-1;
			defaultClass=ai.getMostFrequentClass();
			break;
		case MINOR:
			numClasses=ai.getNumClasses()-1;
			defaultClass=ai.getLeastFrequentClass();
			break;
		case DISABLED:
			numClasses=ai.getNumClasses();
			break;
		case AUTO:
			numClasses=ai.getNumClasses()-1;
			break;
	}

	elitismEnabled=1;	

	smartInit=cm.thereIsParameter(SMART_INIT);
	numAttributes=ai.getNumAttributes();
	numAttributesMC=numAttributes-1;

	smartClassAssignment=cm.thereIsParameter(SMART_CLASS_ASSIGNMENT);

	doRuleCleaning=cm.thereIsParameter(DO_RULE_CLEANING);
	doRuleSplitting=cm.thereIsParameter(DO_RULE_SPLITTING);
	doRuleGeneralizing=cm.thereIsParameter(DO_RULE_GENERALIZING);

	if(cm.thereIsParameter(PROB_LOCAL_SEARCH)) {
		probLocalSearch=cm.getParameter(PROB_LOCAL_SEARCH);
		if(!doRuleCleaning && !doRuleSplitting && !doRuleGeneralizing) probLocalSearch=0;
	} else {
		probLocalSearch=0;
	}

	elitistLocalSearch=cm.thereIsParameter(ELITIST_LOCAL_SEARCH);
	if(elitistLocalSearch) {
		if(!doRuleCleaning && !doRuleSplitting && !doRuleGeneralizing) 
			elitistLocalSearch=0;
	}
}

void timerGlobals::newIteration(int iteration,int lastIt)
{
}

void timerGlobals::dumpStats(int iteration)
{
}
