#include "timerPareto.h"
#include "messageBuffer.h"

extern messageBuffer mb;

timerPareto::timerPareto()
{
	if (cm.getParameter(SELECTION_ALGORITHM)!=PARETO_SELECTION) {
		enabled=0;
		activated=0;
		return;
	}
	enabled=1;

	if(cm.thereIsParameter(PARETO_SELECTION_ITERATION)) {
		startIteration=(int)cm.getParameter(PARETO_SELECTION_ITERATION);
	} else {
		startIteration=0;
	}

	if(startIteration==0) activated=1;
	else activated=0;
}

void timerPareto::newIteration(int iteration,int lastIteration)
{
	if(!enabled) return;

	if(iteration==startIteration) {
		activated=1;
		mb.printf("Iteration %d:Pareto selection activated\n",iteration);
	}
}
