#ifndef _TIMER_PRUNING_H_
#define _TIMER_PRUNING_H_

#include "classifier.h"
#include "timingProcess.h"
#include "agentPerformanceTraining.h"

class timerPruning: public timingProcess {
	int startIteration;
	int enabled;
	int finalIteration;
	int oldState;
	int oldThreshold;

	int autoThreshold;
	int autoThreshold2;
	int autoOffset;

	int policy;

	void frontToBack(classifier &ind,JVector<int> &classifiersToPrune);
	void backToFront(classifier &ind,JVector<int> &classifiersToPrune);
	void random(classifier &ind,JVector<int> &classifiersToPrune);

public:
	int pruningActivated;
	int minClassifiers;
	timerPruning();
	void initialize(populationWrapper *pPW) {pw=pPW;}
	void newIteration(int iteration,int finalIteration);
	void dumpStats(int iteration) {}
	void pruneClassifiers(classifier &ind,agentPerformanceTraining *ap);
	void enable() {pruningActivated=oldState;}
	void disable() {oldState=pruningActivated; pruningActivated=0;}
	void pruneAll() { oldThreshold=minClassifiers; minClassifiers=1;}
	void restoreThreshold() {minClassifiers=oldThreshold;}
};

#endif
