#include "timerSymbolicKR.h"
#include "timerMDL.h"
#include "timerGlobals.h"
#include "attributesInfo.h"
#include "discretizationManager.h"
#include "messageBuffer.h"

extern messageBuffer mb;
extern attributesInfo ai;
extern timerMDL *tMDL;
extern timerGlobals *tGlobals;
extern discretizationManager disc;

timerSymbolicKR::timerSymbolicKR()
{
	int i;

        defaultRuleTheoryLength=0.00000001;

	if(cm.thereIsParameter(KR_ADI) || cm.thereIsParameter(KR_INSTANCE_SET) || cm.thereIsParameter(KR_HYPERRECT)) return;


	if (cm.thereIsParameter(KR_LCS)) {
		probSharp = cm.getParameter(PROB_SHARP);
	} else {
		if(cm.thereIsParameter(PROB_ONE)) {
			tGlobals->probOne = cm.getParameter(PROB_ONE);
		} else {
			int num=ai.getNumAttributesMC();
			int minR=tGlobals->minClassifiersInit;
			double nc=ai.getNumClasses();
			tGlobals->probOne=pow(1-pow(nc,-1.0/minR),1.0/num);
	                if(tGlobals->probOne<0.90) tGlobals->probOne=0.90;
	                mb.printf("Probability of ONE set to %f\n",tGlobals->probOne);
		}

		usePacked=ai.allAttributesBinary();

		if(usePacked) {
			recodeBlocks=(4*(2*ai.getNumAttributesMC()/(8*4*sizeof(unsigned int))+1));
			//recodeBlocks=(2*ai.getNumAttributesMC()/(8*sizeof(unsigned int))+1);
			ruleSize=recodeBlocks+4;
			mb.printf("We will use the binary/SSE optimized gabil representation:%d\n",recodeBlocks);
		} else {
			sizeAttribute = new int[ai.getNumAttributes()];
			offsetAttribute = new int[ai.getNumAttributes()];
			ruleSize = 0;
			for (i = 0; i < ai.getNumAttributesMC(); i++) {
				if (ai.getTypeOfAttribute(i) == REAL) {
					sizeAttribute[i] = disc.getDiscretizer(0)->getNumIntervals(i);
				} else {
					sizeAttribute[i] = ai.getNumValuesAttribute(i);
				}
				offsetAttribute[i] = ruleSize;
				ruleSize += sizeAttribute[i];
			}
			sizeAttribute[i]=1;
			offsetAttribute[i]=ruleSize;
			ruleSize++;
		}

	}
}

void timerSymbolicKR::dumpStats(int iteration)
{
}
