#include "uniformDiscretizer.h"
#include <stdio.h>
#include <stdlib.h>
#include "messageBuffer.h"

extern messageBuffer mb;

void uniformDiscretizer::results()
{
        mb.printf("Numero de punts de tall Discretitzacio : %d\n",numBins-1);

}

void uniformDiscretizer::updateDiscretizer(char *dataFile)
{
	//parserFitxer(dataFile);
	//carregarDades(dataFile);
}

uniformDiscretizer::uniformDiscretizer(int bins, int attributes)
{
	numBins = bins;
	numAttributes = attributes;
	cutPoints = new double *[numAttributes];
	minDomain = new double[numAttributes];
	maxDomain = new double[numAttributes];
}

void uniformDiscretizer::setBounds(double *min, double *max)
{
	int i,j;

	for (i = 0; i < numAttributes; i++) {
		minDomain[i] = min[i];
		maxDomain[i] = max[i];
		double intervalWidth =
		    (maxDomain[i] - minDomain[i]) / (double) numBins;
		cutPoints[i]=new double[numBins-1];
		double cp=min[i];
		for(j=0;j<numBins-1;j++) {
			cp+=intervalWidth;
			cutPoints[i][j]=cp;
		}
	}
	//results();
}

int uniformDiscretizer::discretize(int attribute, double value)
{
	int i;
	
	if (value < minDomain[attribute] || value > maxDomain[attribute]) {
		fprintf(stderr, "Out of bounds value: %f %d:(%f,%f)\n",
			value, attribute, minDomain[attribute],
			maxDomain[attribute]);
		exit(1);
	}

        for(int i=0;i<numBins-1;i++) {
                if(value<cutPoints[attribute][i]) return i;
        }

        return numBins-1;
}
